Load PCFL_aSim.

(*=OaSim*)
Definition OaSim : ExpRelations :=
  Grnd_Exp aSim.

Lemma OaSim_refl : Reflexive OaSim.
Proof.
apply Grnd_Exp_refl.
apply aSim_refl.
Qed.

Lemma OaSim_trans : Transitive OaSim.
Proof.
apply Grnd_Exp_trans.
apply aSim_trans.
Qed.

Definition OaSim_Subclosed : CuS OaSim :=
      @Grnd_Exp_Subclosed aSim.

Instance OaSim_CuSPreord : CuS_Preorder OaSim :=
  {refl  := OaSim_refl;
   trans := OaSim_trans;
   cus   := OaSim_Subclosed}.

Definition aSim_OaSim := (*IncldRel aSim (Exp_Grnd OaSim)*)
      @R_Grnd_Exp aSim tt.

Definition OaSim_aSim := (*IncldRel (Exp_Grnd OaSim) aSim*)
      @Grnd_Exp_R aSim tt.

Lemma OaSim_OPreAdeq : OPreAdequate OaSim.
Proof.
repeat intro.
eapply aSim_PreAdeq.
eapply H.
assumption.
Qed.

Lemma OaSim_LAMrev : forall a E t (e f:Exp (a::E) t),
  OaSim (LAM e) (LAM f) -> OaSim e f.
Proof.
repeat intro.
rewrite (Sub_consSub g).
rewrite consSub_ScS.
repeat rewrite ActionScS.
specialize (H (tlSub g)).
dependent destruction H.
  specialize (H (STmExp (STmL (tlSub g)) e) (EvVal (ValLAM _))).
  repeat dependent destruction H.
apply H0.
Qed.
(*=End *)