Load PCFL_gSim.

(*=OgSim*)
Definition OgSim : ExpRelations :=
    Grnd_Exp gSim.

Definition OgSim_refl : Reflexive OgSim :=
  Grnd_Exp_refl gSim_refl.
Print OgSim_refl.

Definition OgSim_trans : Transitive OgSim :=
  Grnd_Exp_trans gSim_trans.

Definition OgSim_Subclosed : CuS OgSim :=
  Grnd_Exp_Subclosed.

Instance OgSim_CuSPreord : CuS_Preorder OgSim :=
  {refl  := OgSim_refl;
   trans := OgSim_trans;
   cus   := OgSim_Subclosed}.

Definition gSim_OgSim := (*IncldRel gSim (Exp_Grnd OgSim)*)
  @R_Grnd_Exp gSim tt.

Definition OgSim_gSim := (*IncldRel (Exp_Grnd OgSim) gSim*)
  @Grnd_Exp_R gSim tt.
(*=End*)

(*=OgSim_LAMrev*)
Lemma OgSim_LAMrev : forall a E t (e f:Exp (a::E) t),
  OgSim (LAM e) (LAM f) -> OgSim e f.
Proof.
repeat intro.
rewrite (Sub_consSub g).
rewrite consSub_ScS.
repeat rewrite ActionScS.
specialize (H (tlSub g)).
dependent destruction H.
simpl in H.
eapply gSim_trans.
eapply Kle_gSim; eapply Kle_APP;
  try (eapply EvVal; constructor).
eapply gSim_trans.
eapply H.
eapply Kle_gSim; eapply Kle_APP;
  repeat constructor.
Qed.
(*=End*)