Load PCFL_gSim.

(*=aSim in gSim*)
CoInductive aSim : GrndRelations :=
| aSimTOP  : forall u (e f:Exp _ TOP),
             (Ev e (UNIT _) -> Ev f (UNIT _)) -> @aSim u _ e f
| aSimLIST : forall u t (e f:Exp _ (LIST t)),
             (Ev e (NIL _ _) -> Ev f (NIL _ _)) ->
             (forall h t, Ev e (CONS h t) ->
             (exists h' t', Ev f (CONS h' t') /\
                            @aSim u _ h h' /\
                            @aSim u _ t t')) ->
             @aSim u _ e f
| aSimARR  : forall u s t (e f:Exp _ (ARR s t)),
             (forall e', Ev e (LAM e') ->
             (exists f', Ev f (LAM f') /\
                         forall g,
                         @aSim u _ (STmExp {|g|} e') (STmExp {|g|} f'))) ->
             @aSim u _ e f.
Theorem aSim_gSim : aSim <: gSim.
Proof.
cofix aSim_gSim.
repeat intro; destruct e1.
dependent destruction H;
  constructor.
- apply H.
- apply H.
- repeat intro.
  specialize (H0 h t0 H1);
    destruct H0; destruct H0.
  exists x, x0; repeat split.
  + apply H0.
  + apply aSim_gSim; apply H0.
  + apply aSim_gSim; apply H0.
- intro.
  apply aSim_gSim.
  destruct t;
    constructor;
    repeat intro.
  + dependent destruction H0.
    specialize (H _ H0_);
      destruct H; destruct H.
    econstructor; try eassumption.
    specialize (H0 a);
      dependent destruction H0.
    apply H0;
      assumption.
  + dependent destruction H0.
    specialize (H _ H0_);
      destruct H; destruct H.
    specialize (H0 a);
      dependent destruction H0;
      specialize (H0 _ H0_0);
      destruct H0; destruct H0.
    eexists; split; try eassumption.
    econstructor; eassumption.
  + dependent destruction H0.
    specialize (H _ H0_);
      destruct H; destruct H.
    econstructor; try eassumption.
    specialize (H0 a);
      dependent destruction H0.
    apply H0;
      assumption.
  + dependent destruction H0.
    specialize (H _ H0_);
      destruct H; destruct H.
    specialize (H0 a);
      dependent destruction H0.
    specialize (H1 _ _ H0_0);
      repeat destruct H1; destruct H2.
    eexists; eexists; repeat split; try eassumption.
    econstructor; eassumption.
Qed.
(*=End*)