Load PCFL_syntax.

(*=Examples*)
Definition X0 t : Exp [t] t :=
  VAR (ZVAR [] t).
Definition X1 t : Exp [snd t;fst t] (fst t) :=
  VAR (SVAR (snd t) (ZVAR [] (fst t))).
Definition Y1 t : Exp [snd t;fst t] (snd t) :=
  VAR (ZVAR [fst t] (snd t)).
Definition X2 t : Exp [snd (snd t);fst (snd t);fst t] (fst t) :=
  VAR (SVAR (snd (snd t)) (SVAR (fst (snd t)) (ZVAR [] (fst t)))).
Definition Y2 t : Exp [snd (snd t);fst (snd t);fst t] (fst (snd t)) :=
  VAR (SVAR (snd (snd t)) (ZVAR [fst t] (fst (snd t)))).
Definition Z2 t : Exp [snd (snd t);fst (snd t);fst t] (snd (snd t)) :=
  VAR (ZVAR [fst (snd t);fst t] (snd (snd t))).

Definition Id t : Exp [] (ARR t t):=
  LAM (X0 t).
Definition Pi1 t1 t2 : Exp [] (ARR t1 (ARR t2 t1)):=
  LAM (LAM (X1 (t1,t2))).
Definition Pi2 t1 t2 : Exp [] (ARR t1 (ARR t2 t2)):=
  LAM (LAM (Y1 (t1,t2))).
Definition Then t1 t2 : Exp [] (ARR t1 (ARR (ARR t1 t2) t2)):=
  let t := (t1,(ARR t1 t2)) in
  LAM (LAM (APP (Y1 t) (X1 t))).
Definition Comp t1 t2 t3 : Exp [] (ARR (ARR t1 t2) (ARR (ARR t2 t3) (ARR t1 t3))):=
  let t := ((ARR t1 t2),((ARR t2 t3),t1)) in
  LAM (LAM (LAM (APP (Y2 t) (APP (X2 t) (Z2 t))))).

(*=IKS*)
Definition I t : Exp [] (ARR t t):=
  LAM (X0 t).
Definition K t1 t2 : Exp [] (ARR t1 (ARR t2 t1)):=
  LAM (LAM (X1 (t1,t2))).
Definition S t1 t2 t3 : Exp [] (ARR (ARR t1 (ARR t2 t3)) (ARR (ARR t1 t2) (ARR t1 t3))):=
  let t:= (ARR t1 (ARR t2 t3),(ARR t1 t2,t1)) in
  LAM (LAM (LAM (APP (APP (X2 t) (Z2 t)) (APP (Y2 t) (Z2 t))))).
(*=End*)