Load PCFL_OgSim.

(*=Howe gSim*)
Definition gHowe := @Howe OgSim OgSim_CuSPreord.

Lemma gHowe_mim_gSim :
  (forall e:Exp [] TOP, gHowe (UNIT _) e -> Ev e (UNIT _)) /\
  (forall t (e:Exp [] (LIST t)), (gHowe (NIL _ _) e -> Ev e (NIL _ _)) /\
    forall f fl, (gHowe (CONS f fl) e ->
    exists g gl, (Ev e (CONS g gl) /\ gHowe f g /\ gHowe fl gl))) /\
  (forall s t (e f:Exp [] (ARR s t)), gHowe e f ->
    forall x, gHowe (APP e x) (APP f x)).
Proof.
repeat split; intros.
- dependent destruction H. apply OgSim_gSim in H.
  dependent destruction H. apply H. repeat constructor.
- dependent destruction H. apply OgSim_gSim in H.
  dependent destruction H. apply H. repeat constructor.
- dependent destruction H. apply OgSim_gSim in H1.
  dependent destruction H1.
  assert (Ev (CONS f0 fl0) (CONS f0 fl0)); repeat constructor.
  apply H2 in H3; repeat destruct H3; destruct H4.
  exists x, x0; repeat split;
    try assumption;
    eapply Howe_semitrans; try apply gSim_OgSim; eassumption.
- econstructor.
    eassumption.
    apply Howe_refl.
    apply refl.
Qed.

Lemma gHowe_downclosed : forall t (e f g:Exp [] t),
  gHowe e f -> Ev e g -> gHowe g f.
Proof.
repeat intro; dependent induction H0;
  try assumption; dependent destruction H.
- eapply IHEv2.
  eapply Howe_semitrans; try eassumption.
  eapply OgSim_trans; try eassumption.
  apply gSim_OgSim;
    apply Kle_gSim.

  eapply Kle_CASEN.
  eapply gHowe_mim_gSim.
  eapply IHEv1; assumption.

  (*intro; constructor; try assumption.
  eapply gHowe_mim_gSim.
  eapply IHEv1; assumption.*)

- eapply IHEv2.
  eapply IHEv1 in H; apply gHowe_mim_gSim in H;
    repeat destruct H; destruct H3.
  assert (gHowe (STmExp {|h; t|} e2) (STmExp {|x0; x1|} fc)) by
        (eapply Howe_Sub; try eassumption;
         unfold SubRel;
         repeat (dependent destruction v; simpl; try eassumption)).
  eapply Howe_semitrans; try eassumption.
  eapply OgSim_trans; try eassumption.
  apply gSim_OgSim;
    apply Kle_gSim.

  eapply Kle_CASEC.
  assumption.

  (*repeat intro; eapply EvCASEC; eassumption.*)

- eapply IHEv2.
  eapply IHEv1 in H; dependent destruction H.
  assert (gHowe (STmExp {|e2|} e) (STmExp {|fx|} f1)) by
        (eapply Howe_Sub; try eassumption;
         unfold SubRel;
         repeat (dependent destruction v0; simpl; try eassumption)).
  eapply Howe_semitrans; try eassumption.
  eapply OgSim_trans; try eassumption.
  apply gSim_OgSim; apply OgSim_gSim in H0.
  dependent destruction H0.
  eapply gSim_trans; try eapply (H0 fx).
  apply Kle_gSim.

  eapply Kle_APP.
  repeat constructor.

  (*repeat intro; repeat econstructor; assumption.*)

- eapply IHEv.
  assert (gHowe (STmExp {|FIX e|} e) (STmExp {|FIX f0|} f0)) by
        ( eapply Howe_Sub; try eassumption;
         unfold SubRel;
         repeat (dependent destruction v; simpl;
           try (apply Howe_comp; eassumption))).
  eapply Howe_semitrans; try eassumption.
  eapply OgSim_trans; try eassumption.
  apply gSim_OgSim;
    apply Kle_gSim.

  eapply Kle_FIX.

  (*repeat intro; constructor; assumption.*)

Qed.

Lemma gHowe_gSim :  (Exp_Grnd gHowe) <: gSim.
Proof.
cofix gHowe_gSim.
intros u t; intros.
destruct t; constructor; intros.
- apply gHowe_mim_gSim.
  eapply gHowe_downclosed; eassumption.
- apply gHowe_gSim.
  apply Howe_comp.
  assumption.
  apply Howe_refl.
- apply gHowe_mim_gSim.
  eapply gHowe_downclosed; eassumption.
- assert (Howe (CONS h t0) f);
  try (eapply gHowe_downclosed; eassumption);
  apply gHowe_mim_gSim in H1.
  repeat destruct H1.
  destruct H2.
  exists x, x0; repeat split;
  try apply gHowe_gSim; assumption.
Qed.

Theorem gHowe_OgSim :  gHowe <: OgSim.
Proof.
repeat intro.
apply gHowe_gSim.
apply Howe_Sub.
assumption.
apply SubRel_refl.
apply Howe_refl.
Qed.


Corollary gHowe_is_OgSim : gHowe <:> OgSim.
Proof.
unfold EqRel. split.
- apply gHowe_OgSim .
- apply R_Howe.
Qed.

Lemma OgSim_comp : Compatible OgSim.
Proof.
unfold Compatible; repeat split;
intros; apply gHowe_OgSim; apply Howe_comp;
apply R_Howe; assumption.
Qed.

Theorem OgSim_precongruence : Precongruence OgSim.
Proof.
split.
- apply trans.
- apply OgSim_comp.
Qed.
(*=End*)