Load PCFL_Howe.

(*=gSim*)
CoInductive gSim : GrndRelations :=
| gSimTOP  : forall u (e f:Exp _ TOP),
             (Ev e (UNIT _) -> Ev f (UNIT _)) -> @gSim u _ e f
| gSimLIST : forall u t (e f:Exp _ (LIST t)),
             (Ev e (NIL _ _) -> Ev f (NIL _ _)) ->
             (forall h t, Ev e (CONS h t) ->
             (exists h' t', Ev f (CONS h' t') /\
                            @gSim u _ h h' /\
                            @gSim u _ t t')) ->
             @gSim u _ e f
| gSimARR  : forall u s t (e f:Exp _ (ARR s t)), 
             (forall a, @gSim u _ (APP e a) (APP f a)) ->
             @gSim u _ e f.

Lemma gSim_refl : Reflexive gSim.
Proof.
cofix gSimr.
repeat intro; destruct e2;
econstructor; repeat intro; try eassumption; try apply gSimr.

repeat eexists; try eassumption; repeat apply gSimr.

Qed.

Lemma gSim_trans : Transitive gSim.
Proof.
cofix gSimt.
repeat intro; destruct e2;
econstructor; repeat intro;
dependent destruction H0; dependent destruction H; auto;
  try (eapply gSimt; eauto);
  specialize (H0 _ _ H3); repeat destruct H0; destruct H4;
    specialize (H2 _ _ H0); repeat destruct H2; destruct H6;
    repeat eexists;
    try eassumption;
    eapply gSimt; eassumption.
Qed.

Lemma Kle_gSim :  Kle <: gSim.
Proof.
intros u t.
induction t; intros; constructor; intros.
- apply H; assumption.
- eapply IHt2; repeat intro. dependent destruction H0.
  + econstructor;
    try eapply H; eassumption.
  + inversion H0.
- apply H; apply H0.
- exists h, t0; repeat split;
  try apply gSim_refl.
  apply H; apply H0.
Qed.
(* not used *)
Lemma Ev_gSim : forall t (e f:Exp [] t), Ev e f -> @gSim tt _ e f.
Proof.
intros.
apply Kle_gSim; repeat intro.
erewrite Determinacy.
- apply EvVal; eapply Ev_Val_end; eassumption.
- eassumption.
- assumption.
Qed.
(*=End*)